import { IDatabaseConnection } from "@js-soft/docdb-access-abstractions";
import { ILokiJsDatabaseFactory } from "./ILokiJsDatabaseFactory";
import { LokiJsCollectionProvider } from "./LokiJsCollectionProvider";
import { LokiJsOptions } from "./LokiJsOptions";
export declare class LokiJsConnection implements IDatabaseConnection {
    private readonly folder;
    private readonly databaseFactory;
    private readonly lokiJsOptions;
    private readonly providers;
    private static readonly defaultDatabaseFactory;
    constructor(folder: string, databaseFactory?: ILokiJsDatabaseFactory, lokiJsOptions?: LokiJsOptions);
    static fileSystem(folder: string, lokiJsOptions?: Omit<LokiJsOptions, "persistenceMethod">): LokiJsConnection;
    static localStorage(lokiJsOptions?: Omit<LokiJsOptions, "persistenceMethod">): LokiJsConnection;
    static inMemory(lokiJsOptions?: Omit<LokiJsOptions, "persistenceMethod">): LokiJsConnection;
    private onCollectionClosed;
    deleteDatabase(name: string): Promise<void>;
    getDatabase(name: string): Promise<LokiJsCollectionProvider>;
    private closeAllProviders;
    close(): Promise<void>;
}
//# sourceMappingURL=LokiJsConnection.d.ts.map